pro mt_ir_phase_func_driver4

; Program to build namlist.int for IR spectrometer models
; In this version we allow the user to specify which IR pixels to process
; (including all of them)

@c_system.inc
@c_header.inc

start=systime(1)

close,/all

fn='test_all'

cd,'C:\idl\VIMS_vis_Aug2007\idl'


;goto, skip
;stop

; factor for change in tau
fac_80=0.65
fac_30_80=0.75
fac_30=1.01
fac_gr=1.5
fw_0_fac=1.15

; scattering albedo
fw=[0.,0.]

;abs_factor=1.0
altmid_1=80.0
altmid_2=30.0
h=65.0

w_altmid=altmid_1	; change of scattering albedo
w2_altmid=altmid_2
str=''
waves=317
wavl_all=fltarr(waves)
pixel_all=fltarr(waves)




; read in scattering albedos for ir
;scat_alb=fltarr(3,28)
;Read in
;close,19
;openr,19,'C:\idl\Far_IR\Rad_Transfer_VIMS\input\scattering_albedos_900nm_5000nm.dat'
;readf,19,str
;readf,19,scat_alb
;close,19
;wavl_scat_alb=scat_alb(0,*)

; phase functions for visible
;phase_func=fltarr(6,181)
phase_func=fltarr(11,181)
;Read in
close,19
;openr,19,'C:\idl\VIMS_vis\input\phase_func_477nm_965nm.dat'
openr,19,'C:\idl\VIMS_vis_Aug2007\idl\input\phase_func_491nm_934nm.dat'	; newer phase func, may7,07
for j=0,3 do begin
	readf,19,str
endfor
readf,19,phase_func
close,19
;wavl_phase_func=[477, 576, 700, 851, 965]
wavl_phase_func=[491, 531, 555, 600, 634, 670, 675, 751, 830, 934]


;path=string(model,format='("W:\Titan_IR_models\Model_",i3,"\")')
path='C:\idl\VIMS_vis_Aug2007\idl\model\'
;model_num=new_model


; Read the mask of pixels to process
openr,mask_lun,'C:\idl\VIMS_vis_Aug2007\idl\input\pixel_mask_vis.dat',/get_lun
;openr,mask_lun,'C:\idl\VIMS_vis_Aug2007\idl\input\pixel_mask_vis_1 waves.dat',/get_lun
;openr,mask_lun,'C:\idl\VIMS_vis_Aug2007\idl\input\pixel_mask_vis_cont_band_waves.dat',/get_lun
str=''
ulis_mask=intarr(200)
ulis_wavl=fltarr(200)

readf,mask_lun,str

for i=0,199 do begin
  readf,mask_lun,a,b,c
  ulis_mask[a]=c
  ulis_wavl[a]=b
  ;ulis_mask[i]=1
endfor
free_lun,mask_lun


input=fltarr(2,499)
;Read in ground reflectivity
openr,25,'C:\idl\VIMS_vis_Aug2007\idl\input\ground_refl.txt'
readf,25,str
readf,25,str
readf,25,input
close,25
wavl_gr=input(0,*)
ground_refl=input(1,*)


;goto, skipaloo
;input=fltarr(4,317)
;Read in
;openr,25,'C:\idl\Far_IR\Rad_Transfer_VIMS\input\abs_coeff_ir_vims.txt'
;readf,25,str
;readf,25,input
;close,25
;abs_factor_all=input(2,*)
;kabs_all=input(3,*)
;skipaloo:

; model altitudes
altitudes_of_levels=[404.0,298.0,208.0,200.0,192.0,184.0,176.0,168.0, $
  160.0,152.0,144.0,136.0,128.0,120.0,112.0,104.0,96.0,88.0,80.0,72.0, $
  64.0,56.0,48.0,42.0,36.0,30.0,24.0,18.0,12.0,6.0,0.0]

scat_angles=[findgen(100)*0.1,findgen(171)+10.0]
kabs=fltarr(30)

outpath=path
close,2
openr,2,'C:\idl\VIMS_vis_Aug2007\idl\model\namlist.vis'

namlist_str=strarr(42000)
pfuncs_lines=intarr(42000)
wavl_lines=intarr(318)
pfuncs_cntr=0
wavl_cntr=0
n=0
while not eof(2) do begin
  readf,2,str
  namlist_str[n]=str
  if strpos(str,' $pfuncs') ne -1 then begin
    pfuncs_lines[pfuncs_cntr]=n
    pfuncs_cntr=pfuncs_cntr+1
  endif
  if strpos(str,' wavl=') ne -1 then begin
    wavl_lines[wavl_cntr]=n
    wavl_cntr=wavl_cntr+1
  endif
  n=n+1
endwhile
close,2
namlist_str=namlist_str[0:n-1]
pfuncs_lines=pfuncs_lines[0:pfuncs_cntr-1]



; Analyze this array to find the 250 pixels boundaries

pixel_start_lines=intarr(201)
pfuncs_end_lines=intarr(201)
for i=0,199 do begin					; had 34   ???
  diff=wavl_lines[i]-pfuncs_lines
  index=where(diff gt 0)
  diff=abs(wavl_lines[i]-pfuncs_lines[index])
  mindiff=min(diff,subscript)
  pixel_start_lines[i]=pfuncs_lines[subscript]
  diff=pixel_start_lines[i]-pfuncs_lines
  index=where(diff lt 0)
  pfuncs_end_lines[i]=pfuncs_lines[index[0]]-1
endfor
pixel_start_lines[200]=n

close,3
openw,3,outpath+'namlist.aux'


xxx=0
; Loop over pixels
for pixel=0,199 do begin
  if ulis_mask[pixel] then begin
    wavlm=ulis_wavl[pixel]
    wavl_all(xxx)=wavlm
    pixel_all(xxx)=pixel
    xxx=xxx+1

	abs_factor=1
	;abs_factor=abs_factor_all[pixel]
	;if abs_factor eq 0 then kabs_fix=kabs_all(pixel)


	; ground reflectivity from Nature paper for ir
	;gr=3.3644071e-17*ulis_wavl(pixel)^6 - 2.3593688e-13*ulis_wavl(pixel)^5 + 6.8243433e-10*ulis_wavl(pixel)^4 - 1.0421767e-06*ulis_wavl(pixel)^3  $
	;   + 8.8634355e-04*ulis_wavl(pixel)^2 - 3.9824460e-01*ulis_wavl(pixel) + 74.102368

	; Lyn's ground reflectivities for visible
	;wavl_gr=[600.,900.]
	;far_ir_gr=[0.0, 0.0, 0.0, 0.0]
	;far_ir_gr=[0.1, 0.17]*fac_gr

	gr=interpol(ground_refl,wavl_gr,ulis_wavl(pixel))
	gr=gr*fac_gr


	;if ulis_wavl(pixel) lt 600. then gr=0.10


	tau_30 = 33.249*wavlm^(-0.55011)				; sept 26, 2006
	tau_30_80 = 24451*wavlm^(-1.424)				; sept 26, 2006
	tau_80 = 1.7683e07*wavlm^(-2.4251)				; sept 26, 2006



	tau_30_80 = tau_30_80*fac_30_80
	tau_80=tau_80*fac_80
	tau_30=tau_30*fac_30
	taumax=tau_80+tau_30_80+tau_30
	taumid_1=tau_80
	taumid_2=tau_80+tau_30_80

	; scattering albedos for visible
	wavl_fw=[477.3, 605.1, 644.1, 680.0, 753.3, 829.7, 938.]
	fw=[0.96,0.99]
	fup=[0.88,0.945,0.955,0.96,0.965,0.97,0.965]
	flo=[0.95, 0.97, 0.975, 0.98, 0.985, 0.99, 0.99]

	fw(0)=interpol(fup,wavl_fw,ulis_wavl(pixel))
	fw(1)=interpol(flo,wavl_fw,ulis_wavl(pixel))

	fw(0)=(1-fw(0))*fw_0_fac
	fw(0)=1-fw(0)

	;print, wavlm, fw(0), fw(1)


	;fw[0]=interpol(scat_alb(1,*),wavl_scat_alb,ulis_wavl(pixel))
	;fw[1]=interpol(scat_alb(2,*),wavl_scat_alb,ulis_wavl(pixel))
	;if fw[1] gt 0.999 then fw[1]=0.999


	;fw[0]=-8.231e-12*ulis_wavl(pixel)^3 - 7.4266e-09*ulis_wavl(pixel)^2 + 4.674e-06*ulis_wavl(pixel) + 0.96394        ; sept 27
	;fw[1]=-8.231e-12*ulis_wavl(pixel)^3 - 7.4266e-09*ulis_wavl(pixel)^2 + 4.674e-06*ulis_wavl(pixel) + 1.0039      	; sept 27

	;fw[0]=4.8810e-08*ulis_wavl(pixel)^2 - 2.9622e-04*ulis_wavl(pixel) + 1.1438	; sept20, 2006

	;wavl_fw=[5166.0, 4881.0, 4626.0, 4592.0, 4492.0, 4428.0, 4217.0, 3948.0, 3668.0, 3463.0, 3246.0, $
	;		3009.0, 2938.0, 2818.0, 2695.0, 2422.0, 2403.0, 2393.0, 2214.0, 2019.0, 1873.0, 1823.0, $
	;		1813.0, 1802.0, 1381.0]
	;		
	;far_ir_fw=[0.6343139, 0.61410353, 0.39895705, 0.38538802, 0.56357667, 0.62662889, 0.67916537, 0.64959488, $
	;	0.56914734, 0.46404601, 0.37486681, 0.3085254, 0.34877534, 0.57387237, 0.89895785, 0.97400081, 0.98057433, $
	;	0.98279003, 0.98308129, 0.98827916, 0.99236946, 0.99426925, 0.99430899, 0.99435258, 0.99592376]
	;fw(0)=interpol(far_ir_fw,wavl_fw,ulis_wavl(pixel))
	;fw(1)=interpol(far_ir_fw,wavl_fw,ulis_wavl(pixel))

	;if ulis_wavl(pixel) eq 2700. then fw=[0.7,0.7]
	;if ulis_wavl(pixel) eq 3300. then fw=[0.99,0.99]
	;if ulis_wavl(pixel) eq 4300. then fw=[0.2,0.2]

    theta1=45.0
    theta2=60.0
    slope=0.0

	; calculate tabular phase function
	wavl_fix=fix(wavlm)
	wavl_str=string(wavl_fix)
	if wavlm lt 1000. then wavl_str=string(format='(i3)',wavl_fix)
	if wavlm gt 1000. then wavl_str=string(format='(i4)',wavl_fix)

	openw,5,'C:\idl\VIMS_vis_Aug2007\idl\model\phase_'+wavl_str+'.dat'
	phase1=fltarr(181)
	for ph=0,180 do begin
		phase1(ph)=interpol(phase_func(1:10,ph),wavl_phase_func,wavlm)
		printf,5,phase_func(0,ph),phase1(ph)
	endfor
	close, 5
;stop

; Find the index of the layer where the tau structure changes
    ;alt_index=where(abs(altitudes_of_levels-altmid) le 0.1)
    alt_index_1=where(abs(altitudes_of_levels-altmid_1) le 0.1)
    alt_index_2=where(abs(altitudes_of_levels-altmid_2) le 0.1)
    ;if alt_index[0] eq -1 then begin
     ; print,'altmid is not at a level altitude.'
     ; stop
    ;endif else begin
    ;  alt_index=alt_index[0]
   ; endelse

; Find the index of the layer where w changes
    w_alt_index=where(abs(altitudes_of_levels-w_altmid) le 0.1)
    w_alt_index2=where(abs(altitudes_of_levels-w2_altmid) le 0.1)
    if w_alt_index[0] eq -1 then begin
      print,'w_altmid is not at a level altitude.'
      stop
    endif else begin
      w_alt_index=w_alt_index[0]
      w_alt_index2=w_alt_index2[0]
    endelse
    tauhg=fltarr(30)
    wp=fltarr(30)

    ;for i=pixel_start_lines[pixel-8],pfuncs_end_lines[pixel-8]-1 do $
    for i=pixel_start_lines[pixel],pfuncs_end_lines[pixel]-1 do begin
    ;for i=pixel_start_lines[pixel-8],pixel_start_lines[pixel-6]-1 do begin
      ;printf,3,namlist_str[i]
      ;print,namlist_str[i],i
      ;stop
      if strpos(namlist_str[i],' kabs=') ne -1 then begin
        ;print,namlist_str[i],i
        ;stop
        jj=0
        for x=0,5 do begin
        	reads,namlist_str[i+x],aa,bb,cc,dd,ee,format='(8x,5(e14.4,2x))'
        	      ;print,namlist_str[i],i
        	kabs(jj)=aa & kabs(jj+1)=bb & kabs(jj+2)=cc & kabs(jj+3)=dd & kabs(jj+4)=ee
        	jj=jj+5
        endfor
        kabs=kabs*abs_factor
        if abs_factor eq 0 then begin
        	kabs(0:29)=kabs_fix
        endif
        namlist_str(i-5)=string(format='(" kabs=  ",5(e,",",2x))', kabs(0:4))
        namlist_str(i-4)=string(format='("        ",5(e,",",2x))', kabs(5:9))
        namlist_str(i-3)=string(format='("        ",5(e,",",2x))', kabs(10:14))
        namlist_str(i-2)=string(format='("        ",5(e,",",2x))', kabs(15:19))
        namlist_str(i-1)=string(format='("        ",5(e,",",2x))', kabs(20:24))
        namlist_str(i-0)=string(format='("        ",5(e,",",2x))', kabs(25:29))


		for x=5,0,-1 do begin
			;print,namlist_str[i-x]
			printf,3,namlist_str[i-x]
		endfor
		i=i+6
	  endif
	  printf,3,namlist_str[i]
	endfor
    flush,3


;    for i=0,29 do begin
;      if i lt alt_index then begin
;        taucumtop=taumid*exp(-(altitudes_of_levels[i]-altitudes_of_levels[alt_index])/h)
;        taucumbot=taumid*exp(-(altitudes_of_levels[i+1]-altitudes_of_levels[alt_index])/h)
;      endif else begin
;        taucumtop=(taumid-taumax)*altitudes_of_levels[i]/altmid+taumax
;        taucumbot=(taumid-taumax)*altitudes_of_levels[i+1]/altmid+taumax
;      endelse
;      if taucumbot gt 0.0 then begin
;        tauhg[i]=taucumbot-taucumtop>0.0
;      endif else begin
;        tauhg[i]=0.0
;      endelse
    for i=0,29 do begin
      if i lt alt_index_1 then begin
        taucumtop=taumid_1*exp(-(altitudes_of_levels[i]-altitudes_of_levels[alt_index_1])/h)
        taucumbot=taumid_1*exp(-(altitudes_of_levels[i+1]-altitudes_of_levels[alt_index_1])/h)
      endif
      if i ge alt_index_1 and i lt alt_index_2 then begin
        taucumtop=(taumid_2-taumid_1)/(altmid_1-altmid_2)*(altmid_1-altitudes_of_levels[i])+taumid_1
        taucumbot=(taumid_2-taumid_1)/(altmid_1-altmid_2)*(altmid_1-altitudes_of_levels[i+1])+taumid_1
        ;if wavlm gt 900. then stop
      endif
      if i ge alt_index_2 then begin
        taucumtop=(taumid_2-taumax)*altitudes_of_levels[i]/altmid_2+taumax
        taucumbot=(taumid_2-taumax)*altitudes_of_levels[i+1]/altmid_2+taumax
      endif

      if taucumbot gt 0.0 then begin
        tauhg[i]=taucumbot-taucumtop>0.0
      endif else begin
        tauhg[i]=0.0
      endelse
    ;endfor


	; change scattering albedos at differnt altitudes
      if i lt w_alt_index then begin
        wp[i]=fw[0]
      endif else begin
        wp[i]=fw[0]
      endelse

	  if i gt w_alt_index2 then begin
		wp[i]=fw[0]
	  endif
    endfor



    ;print,wavlm,total(tauhg),format='(f8.3," nm taucum_hg= ",f)
    tau_cum_level=fltarr(31)
    for i=0,29 do tau_cum_level[i+1]=tau_cum_level[i]+tauhg[i]

	phasetab='phase_'+wavl_str+'.dat'

	;printf,3,f,g1,g2,format='(" f1= 30*",f6.4,", g1= 30*",f6.4,", g2=30*",f7.4)'
	phasetab="'"+phasetab+"'"
	printf,3,phasetab,format='(" phasetab=30*",a)'
    printf,3,tauhg,format='(" tautab= ",(5(f,",")))'
    printf,3,wp,format='(" wtab= ",(5(f,",")))'
    printf,3,gr,format='(" gr= ",f)'

    ;for i=pfuncs_end_lines[pixel-8],pixel_start_lines[pixel+1-8]-2 do $
    for i=pfuncs_end_lines[pixel],pixel_start_lines[pixel+1]-2 do begin
      if strpos(namlist_str[i],' kabs=') ne -1 then begin

        jj=0
        for x=0,5 do begin
        	reads,namlist_str[i+x],aa,bb,cc,dd,ee,format='(8x,5(e14.4,2x))'
        	      ;print,namlist_str[i],i
        	kabs(jj)=aa & kabs(jj+1)=bb & kabs(jj+2)=cc & kabs(jj+3)=dd & kabs(jj+4)=ee
        	jj=jj+5
        endfor

        kabs=kabs*abs_factor
        if abs_factor eq 0 then begin
        	kabs(0:29)=kabs_fix
        endif
        namlist_str(i-5)=string(format='(" kabs=  ",5(e,",",2x))', kabs(0:4))
        ;print,namlist_str[i-5]
        ;stop
        namlist_str(i-4)=string(format='("        ",5(e,",",2x))', kabs(5:9))
        namlist_str(i-3)=string(format='("        ",5(e,",",2x))', kabs(10:14))
        namlist_str(i-2)=string(format='("        ",5(e,",",2x))', kabs(15:19))
        namlist_str(i-1)=string(format='("        ",5(e,",",2x))', kabs(20:24))
        namlist_str(i-0)=string(format='("        ",5(e,",",2x))', kabs(25:29))


		for x=5,0,-1 do begin
			;print,namlist_str[i-x]
			printf,3,namlist_str[i-x]
		endfor
		i=i+6
	  endif
    		;print,namlist_str[i],i
    	    ;stop

      printf,3,namlist_str[i]

    endfor
      ;printf,3,' $'
  endif
endfor

close,3



openr,3,outpath+'namlist.aux'
openw,4,outpath+'namlist.aux2'
readf,3,str
printf,4,str
last_string='$'
while not eof(3) do begin
	readf,3,str
	if str eq ' $pfuncs' then begin
		if last_string ne ' $' then begin
			printf,4,' $'
		endif
	endif
	printf,4,str
	last_string=str
endwhile

close,3
printf,4,' $'		; use for single wavelength
close,4

wavl_all=reform(wavl_all(0:xxx-1))
pixel_all=reform(pixel_all(0:xxx-1))

cd,outpath

spawn,'del namlist.int'
spawn,'copy namlist.aux2 namlist.int'

stop

;spawn,'rm namlist.int'
;spawn,'mv namlist.aux namlist.int'

skip:


cd,'C:\idl\VIMS_vis_Aug2007\idl\model'

spawn,'intsfracm_271'

spawn,'int6_271m'

spawn,'copy INTENSI.OUT INTENSI_'+fn+'.OUT




; this part reads the INTENSI.OUT file and compares it to VIMS data
cd,'C:\idl\VIMS_vis_Aug2007'

vis_simulation,fn



stop

end
