pro read_intensi_ir2,fn,namlist,numg,wavl,f0,fdd,fd,fup,fnet,iup,idn,alts,solar_zen_angle,theta,phi

; This version reads files created by the Evans code
; Read the file /data/ldoose/INTENSI.OUT
; Obtain:
;    The NAMLIST input for the model
;    The number of Gaussian mesh points
;    The solar flux f0
;    The downward direct flux
;    The downward diffuse flux
;    The upward flux
;    The upward and downward intensities
;    The solar zenith angle
;    The zenith angles at which the intensities are defined
;    The azimuth angles at which the intensities are defined

; The model is assumed to contain 31 layers at less than 250 wavelengths
;print,'filename = ' ,fn

numg=11

; Get the NAMLIST input parameters
namlist=strarr(100000)
str=''
;openr,model_lun,fix_path(model_path+'INTENSI.OUT'),/get_lun
openr,model_lun,'C:\idl\VIMS_vis_Aug2007\idl\model\INTENSI_'+fn+'.OUT',/get_lun
;openr,model_lun,'C:\idl\IR alt spec models 2006\ir_model\INTENSI_'+fn+'.OUT',/get_lun
i=0
len=1
while len gt 0 do begin
  readf,model_lun,str
  len=strlen(str)
  if len gt 0 then begin
    namlist[i]=str
    i=i+1
  endif
endwhile

namlist=namlist[0:i-1]

;reads,str,numg

wavl=fltarr(250)
f0=fltarr(250)
fdd=fltarr(31,250)
fd=fltarr(31,250)
fup=fltarr(31,250)
fnet=fltarr(31,200)
iup=fltarr(38,numg,31,250)
idn=fltarr(38,numg,31,250)
solar_zen_angle=fltarr(31)
gr=fltarr(250)
alts=fltarr(31)

; Loop over wavelengths
theta=fltarr(numg)
iw=0
while not eof(model_lun) do begin

; Read until either 'WAVELENGTH INTERVAL' or ' LEVEL       ALT       TAUA ...' comes up
; Sum F0 values or end of file is encountered
  pos=-1
  f0[iw]=0.0

  while pos eq -1 do begin
    readf,model_lun,str
    if eof(model_lun) ne 0 then goto,done
    pos1=strpos(str,'WAVELENGTH =')
    if pos1 ne -1 then begin
      reads,str,w,ground,format='(13x,f12.0,30x,f10.0)'
      ;if w gt 1269. then stop
      wavl[iw]=w
      gr[iw]=ground
      readf,model_lun,str
      readf,model_lun,sza,format='(21x,f9.0)'
      readf,model_lun,f0temp,format='(19x,f12.0)'
      f0[iw]=f0[iw]+f0temp
    endif
    pos=strpos(str,' LEVEL       ALT       TAUA         DFD          FD          FU        FNET')
    if pos ne -1 then goto,readflux
  endwhile

; Read fluxes
  readflux:
  readf,model_lun,str
  for level=0,30 do begin
    ;readf,model_lun,dum,a,dum,dfdt,fdt,fut,fnt
    readf,model_lun,dum,a,dum,dum,dum,dum,fnt
    alts[level]=a
    ;fdd[level,iw]=dfdt
    ;fd[level,iw]=fdt
    ;fup[level,iw]=fut
    fnet[level,iw]=fnt
  endfor
; Read intensities
  for level=0,30 do begin
;    search_str='UPWARD INTENSITIES'
    search_str='SOLAR ZENITH ANGLE'
    find_string,model_lun,search_str
    reads,search_str,sza,format='(61x,f8.0)'
    for i=0,3 do readf,model_lun,str
    readf,model_lun,theta
    arr=fltarr(numg+2,38)
    readf,model_lun,arr
    iup[*,*,level,iw]=transpose(arr[2:*,*])
    for i=0,4 do readf,model_lun,str
    readf,model_lun,arr
    idn[*,*,level,iw]=transpose(arr[2:*,*])
    solar_zen_angle[level]=sza
  endfor
  iw=iw+1
endwhile

done:

phi=reform(arr[1,*])
wavl=wavl[0:iw-1]*1000.0  ; Convert to nm
f0=f0[0:iw-1]			;   /9.052506^2  ; Corrects to Saturn's mean distance from Sun
fdd=fdd[*,0:iw-1]
fd=fd[*,0:iw-1]
fup=fup[*,0:iw-1]
fnet=fnet[*,0:iw-1]
iup=iup[*,*,*,0:iw-1]
idn=idn[*,*,*,0:iw-1]


end

